library(readr)

# Laster inn datasettet
df <- read_delim("C:/Users/marti/OneDrive - NTNU/Masteroppgave/data/data.csv", 
                 delim = ";", escape_double = FALSE, trim_ws = TRUE)

# De utplukkede variablene av LASSO
variables_selected_1 = c("X50","X81","X67","X79","X146","X140","X82","X154","X107","X121")

# Lager streng som skal brukes i LR
formula_string_1 = paste(variables_selected_1, sep=" ", " + ", collapse = " ")
formula_string_1 = paste("bankrupt_fs ~", formula_string_1)
formula_string_1 = substr(formula_string_1, 1, nchar(formula_string_1)-2) # Remove last +



 # Logistisk regresjon
lrmod_1 <- glm(formula_string_1, data = as.data.frame(df_train_1), family = 'binomial' )

# Henter inn koeffisienter
coefs_1 = data.frame('variable'=rownames(data.frame(coef(lrmod_1))),temp=coef(lrmod_1))
coefs_1 = rbind(coefs_1[-1, ], coefs_1[1, ]) # Moving intercept last

# Henter z-verdier
zscores_1 = summary(lrmod_1)$coefficients[,3]
zscores_1 = data.frame('variable'=rownames(data.frame(zscores_1)),temp=zscores_1)
zscores_1 = rbind(zscores_1[-1, ], zscores_1[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_1$variable){
  char1 = as.character(round(as.numeric(coefs_1[coefs_1$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_1[zscores_1$variable==i,'temp']),digits = 2))
  coefs_1[coefs_1$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_1)[colnames(coefs_1) == 'temp'] = as.character(testaar_1)


#MÅ FJERNES VED DE ANDRE FOLDENE!
coef_df = coefs_1 


# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_1 = as.numeric(pscl::pR2(lrmod_1)["McFadden"])

# In-sample
probs_1 = predict(lrmod_1, data.frame(X_train_1),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_1 = c(metrics_1,roc(y_train_1,probs_1)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_1 = c(metrics_1,BrierScore(y_train_1,probs_1))

# Out-of-sample
probs_1 = predict(lrmod_1, data.frame(X_test_1),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_1 = c(metrics_1,roc(y_test_1,probs_1)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_1 = c(metrics_1,BrierScore(y_test_1,probs_1))

# Formaterer tall
metrics_year_1 = data.frame('variable'=metrics_names,temp=metrics_1)
for(i in metrics_year_1$variable){
  num = metrics_year_1[metrics_year_1$variable==i,'temp']
  if(num<0.05){
    metrics_year_1[metrics_year_1$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_1[metrics_year_1$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_1[metrics_year_1$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_1)[colnames(metrics_year_1) == 'temp'] = as.character(testaar_1)

# Legger til koeffisientene til dataframen

#MÅ FJERNES VED DE ANDRE FOLDENE!
metrics_df = metrics_year_1

# Fjernes for å spare minne/kapasitet
rm(coefs_1,df_test_1,df_train_1,lrmod_1)
rm(metrics_year_1,X_test_1,X_train_1,zscores_1)
rm(formula_string_1,metrics_1,probs_1,testaar_1)
rm(y_test_1,y_train_1,variables_selected_1)

#Fold 2

variables_selected_2 = c("X50","X81","X67","X79","X146","X140","X82","X154","X107","X115")


# Lager streng som skal brukes i LR
formula_string_2 = paste(variables_selected_2, sep=" ", " + ", collapse = " ")
formula_string_2 = paste("bankrupt_fs ~", formula_string_2)
formula_string_2 = substr(formula_string_2, 1, nchar(formula_string_2)-2) # Remove last +



# Logistisk regresjon
lrmod_2 <- glm(formula_string_2, data = as.data.frame(df_train_2), family = 'binomial' )

# Henter inn koeffisienter
coefs_2 = data.frame('variable'=rownames(data.frame(coef(lrmod_2))),temp=coef(lrmod_2))
coefs_2 = rbind(coefs_2[-1, ], coefs_2[1, ]) # Moving intercept last

# Henter z-verdier
zscores_2 = summary(lrmod_2)$coefficients[,3]
zscores_2 = data.frame('variable'=rownames(data.frame(zscores_2)),temp=zscores_2)
zscores_2 = rbind(zscores_2[-1, ], zscores_2[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_2$variable){
  char1 = as.character(round(as.numeric(coefs_2[coefs_2$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_2[zscores_2$variable==i,'temp']),digits = 2))
  coefs_2[coefs_2$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_2)[colnames(coefs_2) == 'temp'] = as.character(testaar_2)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_2,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_2 = as.numeric(pscl::pR2(lrmod_2)["McFadden"])

# In-sample
probs_2 = predict(lrmod_2, data.frame(X_train_2),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_2 = c(metrics_2,roc(y_train_2,probs_2)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_2 = c(metrics_2,BrierScore(y_train_2,probs_2))

# Out-of-sample
probs_2 = predict(lrmod_2, data.frame(X_test_2),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_2 = c(metrics_2,roc(y_test_2,probs_2)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_2 = c(metrics_2,BrierScore(y_test_2,probs_2))

# Formaterer tall
metrics_year_2 = data.frame('variable'=metrics_names,temp=metrics_2)
for(i in metrics_year_2$variable){
  num = metrics_year_2[metrics_year_2$variable==i,'temp']
  if(num<0.05){
    metrics_year_2[metrics_year_2$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_2[metrics_year_2$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_2[metrics_year_2$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_2)[colnames(metrics_year_2) == 'temp'] = as.character(testaar_2)


#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_2,by='variable')



#Fold 3
# Fjernes for å spare minne/kapasitet
rm(coefs_2,df_test_2,df_train_2,lrmod_2)
rm(metrics_year_2,X_test_2,X_train_2,zscores_2)
rm(formula_string_2,metrics_2,probs_2,testaar_2)
rm(y_test_2,y_train_2,variables_selected_2)

variables_selected_3 = c("X50","X81","X67","X79","X146","X140","X82","X154","X107","X115")


# Lager streng som skal brukes i LR
formula_string_3 = paste(variables_selected_3, sep=" ", " + ", collapse = " ")
formula_string_3 = paste("bankrupt_fs ~", formula_string_3)
formula_string_3 = substr(formula_string_3, 1, nchar(formula_string_3)-2) # Remove last +



# Logistisk regresjon
lrmod_3 <- glm(formula_string_3, data = as.data.frame(df_train_3), family = 'binomial' )

# Henter inn koeffisienter
coefs_3 = data.frame('variable'=rownames(data.frame(coef(lrmod_3))),temp=coef(lrmod_3))
coefs_3 = rbind(coefs_3[-1, ], coefs_3[1, ]) # Moving intercept last

# Henter z-verdier
zscores_3 = summary(lrmod_3)$coefficients[,3]
zscores_3 = data.frame('variable'=rownames(data.frame(zscores_3)),temp=zscores_3)
zscores_3 = rbind(zscores_3[-1, ], zscores_3[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_3$variable){
  char1 = as.character(round(as.numeric(coefs_3[coefs_3$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_3[zscores_3$variable==i,'temp']),digits = 2))
  coefs_3[coefs_3$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_3)[colnames(coefs_3) == 'temp'] = as.character(testaar_3)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_3,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_3 = as.numeric(pscl::pR2(lrmod_3)["McFadden"])

# In-sample
probs_3 = predict(lrmod_3, data.frame(X_train_3),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_3 = c(metrics_3,roc(y_train_3,probs_3)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_3 = c(metrics_3,BrierScore(y_train_3,probs_3))

# Out-of-sample
probs_3 = predict(lrmod_3, data.frame(X_test_3),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_3 = c(metrics_3,roc(y_test_3,probs_3)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_3 = c(metrics_3,BrierScore(y_test_3,probs_3))

# Formaterer tall
metrics_year_3 = data.frame('variable'=metrics_names,temp=metrics_3)
for(i in metrics_year_3$variable){
  num = metrics_year_3[metrics_year_3$variable==i,'temp']
  if(num<0.05){
    metrics_year_3[metrics_year_3$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_3[metrics_year_3$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_3[metrics_year_3$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_3)[colnames(metrics_year_3) == 'temp'] = as.character(testaar_3)


#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_3,by='variable')






#Fold 4
# Fjernes for å spare minne/kapasitet
rm(coefs_3,df_test_3,df_train_3,lrmod_3)
rm(metrics_year_3,X_test_3,X_train_3,zscores_3)
rm(formula_string_3,metrics_3,probs_3,testaar_3)
rm(y_test_3,y_train_3,variables_selected_3)

variables_selected_4 = c("X50","X81","X67","X79","X146","X140","X82","X154","X107","X87")

# Lager streng som skal brukes i LR
formula_string_4 = paste(variables_selected_4, sep=" ", " + ", collapse = " ")
formula_string_4 = paste("bankrupt_fs ~", formula_string_4)
formula_string_4 = substr(formula_string_4, 1, nchar(formula_string_4)-2) # Remove last +



# Logistisk regresjon
lrmod_4 <- glm(formula_string_4, data = as.data.frame(df_train_4), family = 'binomial' )

# Henter inn koeffisienter
coefs_4 = data.frame('variable'=rownames(data.frame(coef(lrmod_4))),temp=coef(lrmod_4))
coefs_4 = rbind(coefs_4[-1, ], coefs_4[1, ]) # Moving intercept last

# Henter z-verdier
zscores_4 = summary(lrmod_4)$coefficients[,3]
zscores_4 = data.frame('variable'=rownames(data.frame(zscores_4)),temp=zscores_4)
zscores_4 = rbind(zscores_4[-1, ], zscores_4[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_4$variable){
  char1 = as.character(round(as.numeric(coefs_4[coefs_4$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_4[zscores_4$variable==i,'temp']),digits = 2))
  coefs_4[coefs_4$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_4)[colnames(coefs_4) == 'temp'] = as.character(testaar_4)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_4,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_4 = as.numeric(pscl::pR2(lrmod_4)["McFadden"])

# In-sample
probs_4 = predict(lrmod_4, data.frame(X_train_4),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_4 = c(metrics_4,roc(y_train_4,probs_4)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_4 = c(metrics_4,BrierScore(y_train_4,probs_4))

# Out-of-sample
probs_4 = predict(lrmod_4, data.frame(X_test_4),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_4 = c(metrics_4,roc(y_test_4,probs_4)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_4 = c(metrics_4,BrierScore(y_test_4,probs_4))

# Formaterer tall
metrics_year_4 = data.frame('variable'=metrics_names,temp=metrics_4)
for(i in metrics_year_4$variable){
  num = metrics_year_4[metrics_year_4$variable==i,'temp']
  if(num<0.05){
    metrics_year_4[metrics_year_4$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_4[metrics_year_4$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_4[metrics_year_4$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_4)[colnames(metrics_year_4) == 'temp'] = as.character(testaar_4)


#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_4,by='variable')




#Fold 5
# Fjernes for å spare minne/kapasitet
rm(coefs_4,df_test_4,df_train_4,lrmod_4)
rm(metrics_year_4,X_test_4,X_train_4,zscores_4)
rm(formula_string_4,metrics_4,probs_4,testaar_4)
rm(y_test_4,y_train_4,variables_selected_4)

variables_selected_5 = c("X50","X81","X67","X79","X146","X140","X82","X154","X107","X87")

# Lager streng som skal brukes i LR
formula_string_5 = paste(variables_selected_5, sep=" ", " + ", collapse = " ")
formula_string_5 = paste("bankrupt_fs ~", formula_string_5)
formula_string_5 = substr(formula_string_5, 1, nchar(formula_string_5)-2) # Remove last +



# Logistisk regresjon
lrmod_5 <- glm(formula_string_5, data = as.data.frame(df_train_5), family = 'binomial' )

# Henter inn koeffisienter
coefs_5 = data.frame('variable'=rownames(data.frame(coef(lrmod_5))),temp=coef(lrmod_5))
coefs_5 = rbind(coefs_5[-1, ], coefs_5[1, ]) # Moving intercept last

# Henter z-verdier
zscores_5 = summary(lrmod_5)$coefficients[,3]
zscores_5 = data.frame('variable'=rownames(data.frame(zscores_5)),temp=zscores_5)
zscores_5 = rbind(zscores_5[-1, ], zscores_5[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_5$variable){
  char1 = as.character(round(as.numeric(coefs_5[coefs_5$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_5[zscores_5$variable==i,'temp']),digits = 2))
  coefs_5[coefs_5$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_5)[colnames(coefs_5) == 'temp'] = as.character(testaar_5)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_5,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_5 = as.numeric(pscl::pR2(lrmod_5)["McFadden"])

# In-sample
probs_5 = predict(lrmod_5, data.frame(X_train_5),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_5 = c(metrics_5,roc(y_train_5,probs_5)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_5 = c(metrics_5,BrierScore(y_train_5,probs_5))

# Out-of-sample
probs_5 = predict(lrmod_5, data.frame(X_test_5),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_5 = c(metrics_5,roc(y_test_5,probs_5)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_5 = c(metrics_5,BrierScore(y_test_5,probs_5))

# Formaterer tall
metrics_year_5 = data.frame('variable'=metrics_names,temp=metrics_5)
for(i in metrics_year_5$variable){
  num = metrics_year_5[metrics_year_5$variable==i,'temp']
  if(num<0.05){
    metrics_year_5[metrics_year_5$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_5[metrics_year_5$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_5[metrics_year_5$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_5)[colnames(metrics_year_5) == 'temp'] = as.character(testaar_5)

#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_5,by='variable')




#Fold 6
# Fjernes for å spare minne/kapasitet
rm(coefs_5,df_test_5,df_train_5,lrmod_5)
rm(metrics_year_5,X_test_5,X_train_5,zscores_5)
rm(formula_string_5,metrics_5,probs_5,testaar_5)
rm(y_test_5,y_train_5,variables_selected_5)

variables_selected_6 = c("X50","X81","X67","X79","X146","X140","X82","X154","X107","X87")

# Lager streng som skal brukes i LR
formula_string_6 = paste(variables_selected_6, sep=" ", " + ", collapse = " ")
formula_string_6 = paste("bankrupt_fs ~", formula_string_6)
formula_string_6 = substr(formula_string_6, 1, nchar(formula_string_6)-2) # Remove last +



# Logistisk regresjon
lrmod_6 <- glm(formula_string_6, data = as.data.frame(df_train_6), family = 'binomial' )

# Henter inn koeffisienter
coefs_6 = data.frame('variable'=rownames(data.frame(coef(lrmod_6))),temp=coef(lrmod_6))
coefs_6 = rbind(coefs_6[-1, ], coefs_6[1, ]) # Moving intercept last

# Henter z-verdier
zscores_6 = summary(lrmod_6)$coefficients[,3]
zscores_6 = data.frame('variable'=rownames(data.frame(zscores_6)),temp=zscores_6)
zscores_6 = rbind(zscores_6[-1, ], zscores_6[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_6$variable){
  char1 = as.character(round(as.numeric(coefs_6[coefs_6$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_6[zscores_6$variable==i,'temp']),digits = 2))
  coefs_6[coefs_6$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_6)[colnames(coefs_6) == 'temp'] = as.character(testaar_6)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_6,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_6 = as.numeric(pscl::pR2(lrmod_6)["McFadden"])

# In-sample
probs_6 = predict(lrmod_6, data.frame(X_train_6),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_6 = c(metrics_6,roc(y_train_6,probs_6)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_6 = c(metrics_6,BrierScore(y_train_6,probs_6))

# Out-of-sample
probs_6 = predict(lrmod_6, data.frame(X_test_6),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_6 = c(metrics_6,roc(y_test_6,probs_6)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_6 = c(metrics_6,BrierScore(y_test_6,probs_6))

# Formaterer tall
metrics_year_6 = data.frame('variable'=metrics_names,temp=metrics_6)
for(i in metrics_year_6$variable){
  num = metrics_year_6[metrics_year_6$variable==i,'temp']
  if(num<0.05){
    metrics_year_6[metrics_year_6$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_6[metrics_year_6$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_6[metrics_year_6$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_6)[colnames(metrics_year_6) == 'temp'] = as.character(testaar_6)

#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_6,by='variable')





#Fold 7
# Fjernes for å spare minne/kapasitet
rm(coefs_6,df_test_6,df_train_6,lrmod_6)
rm(metrics_year_6,X_test_6,X_train_6,zscores_6)
rm(formula_string_6,metrics_6,probs_6,testaar_6)
rm(y_test_6,y_train_6,variables_selected_6)

variables_selected_7 = c("X50","X81","X67","X79","X146","X140","X82","X154","X107","X87")

# Lager streng som skal brukes i LR
formula_string_7 = paste(variables_selected_7, sep=" ", " + ", collapse = " ")
formula_string_7 = paste("bankrupt_fs ~", formula_string_7)
formula_string_7 = substr(formula_string_7, 1, nchar(formula_string_7)-2) # Remove last +



# Logistisk regresjon
lrmod_7 <- glm(formula_string_7, data = as.data.frame(df_train_7), family = 'binomial' )

# Henter inn koeffisienter
coefs_7 = data.frame('variable'=rownames(data.frame(coef(lrmod_7))),temp=coef(lrmod_7))
coefs_7 = rbind(coefs_7[-1, ], coefs_7[1, ]) # Moving intercept last

# Henter z-verdier
zscores_7 = summary(lrmod_7)$coefficients[,3]
zscores_7 = data.frame('variable'=rownames(data.frame(zscores_7)),temp=zscores_7)
zscores_7 = rbind(zscores_7[-1, ], zscores_7[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_7$variable){
  char1 = as.character(round(as.numeric(coefs_7[coefs_7$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_7[zscores_7$variable==i,'temp']),digits = 2))
  coefs_7[coefs_7$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_7)[colnames(coefs_7) == 'temp'] = as.character(testaar_7)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_7,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_7 = as.numeric(pscl::pR2(lrmod_7)["McFadden"])

# In-sample
probs_7 = predict(lrmod_7, data.frame(X_train_7),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_7 = c(metrics_7,roc(y_train_7,probs_7)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_7 = c(metrics_7,BrierScore(y_train_7,probs_7))

# Out-of-sample
probs_7 = predict(lrmod_7, data.frame(X_test_7),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_7 = c(metrics_7,roc(y_test_7,probs_7)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_7 = c(metrics_7,BrierScore(y_test_7,probs_7))

# Formaterer tall
metrics_year_7 = data.frame('variable'=metrics_names,temp=metrics_7)
for(i in metrics_year_7$variable){
  num = metrics_year_7[metrics_year_7$variable==i,'temp']
  if(num<0.05){
    metrics_year_7[metrics_year_7$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_7[metrics_year_7$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_7[metrics_year_7$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_7)[colnames(metrics_year_7) == 'temp'] = as.character(testaar_7)

#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_7,by='variable')





#Fold 8
# Fjernes for å spare minne/kapasitet
rm(coefs_7,df_test_7,df_train_7,lrmod_7)
rm(metrics_year_7,X_test_7,X_train_7,zscores_7)
rm(formula_string_7,metrics_7,probs_7,testaar_7)
rm(y_test_7,y_train_7,variables_selected_7)

variables_selected_8 = c("X50","X81","X67","X79","X146","X140","X82","X154","X115","X87")

# Lager streng som skal brukes i LR
formula_string_8 = paste(variables_selected_8, sep=" ", " + ", collapse = " ")
formula_string_8 = paste("bankrupt_fs ~", formula_string_8)
formula_string_8 = substr(formula_string_8, 1, nchar(formula_string_8)-2) # Remove last +



# Logistisk regresjon
lrmod_8 <- glm(formula_string_8, data = as.data.frame(df_train_8), family = 'binomial' )

# Henter inn koeffisienter
coefs_8 = data.frame('variable'=rownames(data.frame(coef(lrmod_8))),temp=coef(lrmod_8))
coefs_8 = rbind(coefs_8[-1, ], coefs_8[1, ]) # Moving intercept last

# Henter z-verdier
zscores_8 = summary(lrmod_8)$coefficients[,3]
zscores_8 = data.frame('variable'=rownames(data.frame(zscores_8)),temp=zscores_8)
zscores_8 = rbind(zscores_8[-1, ], zscores_8[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_8$variable){
  char1 = as.character(round(as.numeric(coefs_8[coefs_8$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_8[zscores_8$variable==i,'temp']),digits = 2))
  coefs_8[coefs_8$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_8)[colnames(coefs_8) == 'temp'] = as.character(testaar_8)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_8,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_8 = as.numeric(pscl::pR2(lrmod_8)["McFadden"])

# In-sample
probs_8 = predict(lrmod_8, data.frame(X_train_8),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_8 = c(metrics_8,roc(y_train_8,probs_8)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_8 = c(metrics_8,BrierScore(y_train_8,probs_8))

# Out-of-sample
probs_8 = predict(lrmod_8, data.frame(X_test_8),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_8 = c(metrics_8,roc(y_test_8,probs_8)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_8 = c(metrics_8,BrierScore(y_test_8,probs_8))

# Formaterer tall
metrics_year_8 = data.frame('variable'=metrics_names,temp=metrics_8)
for(i in metrics_year_8$variable){
  num = metrics_year_8[metrics_year_8$variable==i,'temp']
  if(num<0.05){
    metrics_year_8[metrics_year_8$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_8[metrics_year_8$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_8[metrics_year_8$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_8)[colnames(metrics_year_8) == 'temp'] = as.character(testaar_8)

#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_8,by='variable')



#Fold 9
# Fjernes for å spare minne/kapasitet
rm(coefs_8,df_test_8,df_train_8,lrmod_8)
rm(metrics_year_8,X_test_8,X_train_8,zscores_8)
rm(formula_string_8,metrics_8,probs_8,testaar_8)
rm(y_test_8,y_train_8,variables_selected_8)

variables_selected_9 = c("X50","X81","X67","X79","X146","X140","X82","X154","X115","X87")

# Lager streng som skal brukes i LR
formula_string_9 = paste(variables_selected_9, sep=" ", " + ", collapse = " ")
formula_string_9 = paste("bankrupt_fs ~", formula_string_9)
formula_string_9 = substr(formula_string_9, 1, nchar(formula_string_9)-2) # Remove last +



# Logistisk regresjon
lrmod_9 <- glm(formula_string_9, data = as.data.frame(df_train_9), family = 'binomial' )

# Henter inn koeffisienter
coefs_9 = data.frame('variable'=rownames(data.frame(coef(lrmod_9))),temp=coef(lrmod_9))
coefs_9 = rbind(coefs_9[-1, ], coefs_9[1, ]) # Moving intercept last

# Henter z-verdier
zscores_9 = summary(lrmod_9)$coefficients[,3]
zscores_9 = data.frame('variable'=rownames(data.frame(zscores_9)),temp=zscores_9)
zscores_9 = rbind(zscores_9[-1, ], zscores_9[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_9$variable){
  char1 = as.character(round(as.numeric(coefs_9[coefs_9$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_9[zscores_9$variable==i,'temp']),digits = 2))
  coefs_9[coefs_9$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_9)[colnames(coefs_9) == 'temp'] = as.character(testaar_9)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_9,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_9 = as.numeric(pscl::pR2(lrmod_9)["McFadden"])

# In-sample
probs_9 = predict(lrmod_9, data.frame(X_train_9),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_9 = c(metrics_9,roc(y_train_9,probs_9)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_9 = c(metrics_9,BrierScore(y_train_9,probs_9))

# Out-of-sample
probs_9 = predict(lrmod_9, data.frame(X_test_9),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_9 = c(metrics_9,roc(y_test_9,probs_9)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_9 = c(metrics_9,BrierScore(y_test_9,probs_9))

# Formaterer tall
metrics_year_9 = data.frame('variable'=metrics_names,temp=metrics_9)
for(i in metrics_year_9$variable){
  num = metrics_year_9[metrics_year_9$variable==i,'temp']
  if(num<0.05){
    metrics_year_9[metrics_year_9$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_9[metrics_year_9$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_9[metrics_year_9$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_9)[colnames(metrics_year_9) == 'temp'] = as.character(testaar_9)


#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_9,by='variable')




#Fold 10
# Fjernes for å spare minne/kapasitet
rm(coefs_9,df_test_9,df_train_9,lrmod_9)
rm(metrics_year_9,X_test_9,X_train_9,zscores_9)
rm(formula_string_9,metrics_9,probs_9,testaar_9)
rm(y_test_9,y_train_9,variables_selected_9)

variables_selected_10 = c("X50","X81","X67","X79","X146","X140","X82","X154","X115","X87")

# Lager streng som skal brukes i LR
formula_string_10 = paste(variables_selected_10, sep=" ", " + ", collapse = " ")
formula_string_10 = paste("bankrupt_fs ~", formula_string_10)
formula_string_10 = substr(formula_string_10, 1, nchar(formula_string_10)-2) # Remove last +



# Logistisk regresjon
lrmod_10 <- glm(formula_string_10, data = as.data.frame(df_train_10), family = 'binomial' )

# Henter inn koeffisienter
coefs_10 = data.frame('variable'=rownames(data.frame(coef(lrmod_10))),temp=coef(lrmod_10))
coefs_10 = rbind(coefs_10[-1, ], coefs_10[1, ]) # Moving intercept last

# Henter z-verdier
zscores_10 = summary(lrmod_10)$coefficients[,3]
zscores_10 = data.frame('variable'=rownames(data.frame(zscores_10)),temp=zscores_10)
zscores_10 = rbind(zscores_10[-1, ], zscores_10[1, ]) # Moving intercept last

# Formaterer tall og setter z-verdier i parentes
for(i in coefs_10$variable){
  char1 = as.character(round(as.numeric(coefs_10[coefs_10$variable==i,'temp']),digits = 2))
  char2 = as.character(round(as.numeric(zscores_10[zscores_10$variable==i,'temp']),digits = 2))
  coefs_10[coefs_10$variable==i,'temp'] = paste(char1,'(',char2,')',sep='')
}

# Gir nytt navn til testår
colnames(coefs_10)[colnames(coefs_10) == 'temp'] = as.character(testaar_10)

#Legger verdiene til i datasettet
coef_df = left_join(coef_df, coefs_10,by="variable")

# McFaddens R squared
metrics_names = 'McFaddens_R'
metrics_10 = as.numeric(pscl::pR2(lrmod_10)["McFadden"])

# In-sample
probs_10 = predict(lrmod_10, data.frame(X_train_10),type = 'response')

metrics_names = c(metrics_names,'AUC_in_sample')
metrics_10 = c(metrics_10,roc(y_train_10,probs_10)$auc)

metrics_names = c(metrics_names,'Brierscore_in_sample')
metrics_10 = c(metrics_10,BrierScore(y_train_10,probs_10))

# Out-of-sample
probs_10 = predict(lrmod_10, data.frame(X_test_10),type = 'response')

metrics_names = c(metrics_names,'AUC_out_of_sample')
metrics_10 = c(metrics_10,roc(y_test_10,probs_10)$auc)

metrics_names = c(metrics_names,'Brierscore_out_of_sample')
metrics_10 = c(metrics_10,BrierScore(y_test_10,probs_10))

# Formaterer tall
metrics_year_10 = data.frame('variable'=metrics_names,temp=metrics_10)
for(i in metrics_year_10$variable){
  num = metrics_year_10[metrics_year_10$variable==i,'temp']
  if(num<0.05){
    metrics_year_10[metrics_year_10$variable==i,'temp'] = formatC(as.numeric(num), format = "e",digits=2)
  }else{
    metrics_year_10[metrics_year_10$variable==i,'temp'] = as.character(round(as.numeric(metrics_year_10[metrics_year_10$variable==i,'temp']),digits=2))
  }
}
colnames(metrics_year_10)[colnames(metrics_year_10) == 'temp'] = as.character(testaar_10)


#Legger verdiene til i datasettet
metrics_df = left_join(metrics_df, metrics_year_10,by='variable')

##################################
## Setter sammen til en tabell
##################################

# Setter sammen koeffisienter og evalueringsverdier
results_df = rbind(coef_df,metrics_df)

# Endrer navn
results_df[results_df$variable=='(Intercept)','variable'] = 'Intercept' 

# Lagrer til Excel-fil
filename = paste(paste('C:/Users/marti/OneDrive - NTNU/Masteroppgave/results',sep=''),'.xlsx',sep='')
write_xlsx(results_df, filename)
